package gstd;
/**
 * Constants used for the GSTD
 * 
 * @author <a href='mailto:mallett@cs.ualberta.ca'>Daniel Mallett</a>
 * @version %I%, %G%
 */
public interface Constants {

    //constants
    public static final short   NDIMS = 2; //number of dimensions
    public static final int     MAXN = 100000; //maximum number of objects
    
    public static final float   ERR = (float)0.000001;
    
    public static final short   NOW  = 1;

    //rectangle or point objects string constants
    public static final char    POINT_OBJECT_TYPE = 'p';
    public static final char    RECTANGLE_OBJECT_TYPE = 'r';

    //adjustment or radar approach string constants
    public static final char    RADAR_APPROACH = 'r';
    public static final char    ADJUST_APPROACH = 'a';
    public static final char    TOROID_APPROACH = 't';

    //distribution constants
    public static final char    GAUSSIAN_DISTRIBUTION = 'g';
    public static final char    SKEWED_DISTRIBUTION = 's';
    public static final char    RANDOM_DISTRIBUTION = 'r';
    public static final char    USER_DISTRIBUTION = 'u';

    //formating constants
    public static final short   MIN_EXTENT_DIGITS = 5;
    public static final short   MAX_EXTENT_DIGITS = 5;
    public static final short   MIN_TIME_DIGITS = 6;
    public static final short   MAX_TIME_DIGITS = 6;

    //maximum number of datasets
    public static final short   MAX_DATASETS = 10;

    //maximum number of snapshots
    public static final int     MAX_SNAPSHOTS = 1000;

    //maximum density used when generating infrastructure frameworks
    public static final float   FRAMEWORK_DENSITY = (float)0.2;
    public static final char    FRAMEWORK_EXTENT_TYPE_CONSTANT = 'c';
    public static final char    FRAMEWORK_EXTENT_TYPE_VARIABLE = 'v';

    //maximum number of rectangles to generate for a framework
    public static final short   FRAMEWORK_MAX_RECTANGLES = 100;

}

