package gstd;
/**
 * Implements Gaussian Distribution
 * 
 * @author <a href='mailto:mallett@cs.ualberta.ca'>Daniel Mallett</a>
 * @version %I%, %G%
 */

import java.util.*;

public class DistributionGaussian extends Distribution {
    private float fltMean;
    private float fltSigma;
    
    public DistributionGaussian (float mean, float sigma, 
				 float[] min, float[] max) {
	super("Gaussian",min,max);
	fltMean = mean;
	fltSigma = sigma;
    }

    /**
     * return a random number that follows the given distribution
     */
    public float getRandom(Random random, float min, float max) {
	//have to scale gaussian
	float fltGaus;
	do {
	    fltGaus = fltMean + fltSigma*(float)random.nextGaussian();

	} while ((fltGaus < min) || (fltGaus > max));
	return fltGaus;
    }

    public String getName() {
	return strName + "_" + fltMean + "_" + fltSigma;
    }
    public String getMean() {
	return (new Float(fltMean)).toString();
    }
    public String getSigma() {
	return (new Float(fltSigma)).toString();
    }
}



