package gstd;
/**
 * Implements a Uniform Random Distribution
 * 
 * @author <a href='mailto:mallett@cs.ualberta.ca'>Daniel Mallett</a>
 * @version %I%, %G%
 */

import java.util.*;

public class DistributionRandom extends Distribution {
    public DistributionRandom (float[] min, float[] max) {
	super("Random",min,max);
    }
    
    public float getRandom(Random random, float min, float max) {
	float x;

	do
	    x = random.nextFloat();
	while ( x == 0 || x == 1);
	//x is now between 0 and 1
	
	// scale x so it is between x1 and x2
	return (max - min ) * x + min;
    }

    public String getName() {
	return strName;
    }
}



