package gstd;

import java.util.*;

/**
 * Framework
 *
 * @author <a href='mailto:mallett@cs.ualberta.ca'>Daniel Mallett</a>
 * @version %I%, %G%
 */
public class Framework implements Constants {
    private Vector vecSpaceStamp;
    private int index = 0;

    public Framework(int numRectangles) {
	vecSpaceStamp = new Vector(numRectangles);
    }

    public void addRectangle(SpaceStamp ss) {
	vecSpaceStamp.add(ss);
    }

    public boolean intersects(SpaceStamp ss) {
	for (int i = 0; i < vecSpaceStamp.size(); i++)
	    if (((SpaceStamp)vecSpaceStamp.elementAt(i)).intersects(ss))
		return true;
	return false;
    }

    /**
     * if the spacestamp intersects the framework adjust the spacestamp
     *
     */
    public void adjust(SpaceStamp ss, SpaceStamp ssOld) {
	boolean adjust = true;
	while (adjust) {
	    adjust = false;
	    for (int i = 0; i < vecSpaceStamp.size(); i++) {
		if ( ((SpaceStamp)vecSpaceStamp.elementAt(i)).intersects(ss)) {
		    //adjust ss - XXX only works for points XXX
		    float[] center = ss.getCenter();
		    float[] centerOld;
		    if (ssOld == null) {
			centerOld = new float[] {(float)0.0,(float)0.0};
		    } else {
			centerOld = ssOld.getCenter();
		    }
		    float[] extent = ((SpaceStamp)vecSpaceStamp.elementAt(i)).getExtents();

		    //XXX - only works for 2D
		    if (center[0] > extent[0] && centerOld[0] < center[0])
			center[0] = extent[0];
		    else if (center[0] < extent[2] && centerOld[0] > center[0])
			center[0] = extent[2];
		    else if (center[1] > extent[1] && centerOld[1] < center[1])
			center[1] = extent[1];
		    else if (center[1] < extent[3] && centerOld[1] > center[1]) 
			center[1] = extent[3];

		    ss.setCenter(center);
		    //test again
		    adjust = true;
		    break;
		}
	    }
	}
    }

    public int getNumRects() {
	return vecSpaceStamp.size();
    }

}
