package gstd;
/**
 * Instance of a data point or rectangle in a given space and time.
 *
 * @author <a href='mailto:mallett@cs.ualberta.ca'>Daniel Mallett</a>
 * @version %I%, %G%
 */
public class Instance implements Cloneable {
    private int intID;
    private TimeStamp tst;
    private SpaceStamp sst;
    private boolean correct_p;

    public Instance(int id, boolean correct, SpaceStamp ss, TimeStamp ts) {
	intID = id;
	tst = ts;
	sst = ss;
	correct_p = correct;
	
    }

    public Instance() {
    }
    public int getID() {
	return intID;
    } 
    public TimeStamp getTimeStamp() {
	return tst;
    } 
    public SpaceStamp getSpaceStamp() {
	return sst;
    }
    public boolean getCurrent() {
	return correct_p;
    }
    public void setID(int id) {
	intID = id;
    } 
    public void setTimeStamp(TimeStamp ts) {
	tst = ts;
    } 
    public void setSpaceStamp(SpaceStamp ss) {
	sst = ss;
    }
    public void setCurrent(boolean bool) {
	correct_p = bool;
    }
    public void setCurrent() {
	setCurrent(true);
    }
    public boolean isCurrent() {
	return correct_p;
    }
    public Object clone() {
	return new Instance(intID,correct_p,(SpaceStamp)sst.clone(),(TimeStamp)tst.clone());
    }
}
