package gstd;
/**
 * Space stamp is center point and extents
 *
 * @author <a href='mailto:mallett@cs.ualberta.ca'>Daniel Mallett</a>
 * @version %I%, %G%
 */
public class TimeStamp implements Cloneable {
    private float tt; // transaction time
    private float vt; // valid time

    public TimeStamp() {
	tt = 0;
	vt = 0;
    }

    public TimeStamp(float t, float v) {
	tt = t;
	vt = v;
    }

    public final String getTime() {
	return new Double(tt).toString();
    }

    public final void update(float deltaT) {
	tt += deltaT;
    }

    public final float getTransactionTime() {
	return tt;
    }

    public final void setTransactionTime(float newTT) {
	tt = newTT;
    }

    public Object clone() {
	return new TimeStamp(tt,0);
    }
}

